package com.fs.wx.sop.mapper;

import java.util.List;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import com.fs.common.annotation.DataSource;
import com.fs.common.enums.DataSourceType;
import com.fs.sop.params.WxSopTagsParam;
import com.fs.sop.vo.WxFilterSopCustomersResult;
import com.fs.wx.sop.domain.WxSop;

/**
 * 个微SOPMapper接口
 *
 * @author 吴树波
 * @date 2026-02-24
 */
public interface WxSopMapper extends BaseMapper<WxSop>{
    /**
     * 查询个微SOP
     *
     * @param id 个微SOP主键
     * @return 个微SOP
     */
    @DataSource(DataSourceType.SOP)
    WxSop selectWxSopById(Long id);

    /**
     * 查询个微SOP列表
     *
     * @param wxSop 个微SOP
     * @return 个微SOP集合
     */
    @DataSource(DataSourceType.SOP)
    List<WxSop> selectWxSopList(WxSop wxSop);

    /**
     * 新增个微SOP
     *
     * @param wxSop 个微SOP
     * @return 结果
     */
    int insertWxSop(WxSop wxSop);

    /**
     * 修改个微SOP
     *
     * @param wxSop 个微SOP
     * @return 结果
     */
    int updateWxSop(WxSop wxSop);

    /**
     * 删除个微SOP
     *
     * @param id 个微SOP主键
     * @return 结果
     */
    int deleteWxSopById(Long id);

    /**
     * 批量删除个微SOP
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    int deleteWxSopByIds(Long[] ids);

    /**
     * 根据ID数组查询个微SOP列表
     *
     * @param ids 个微SOP主键数组
     * @return 个微SOP集合
     */
    List<WxSop> selectWxSopByIds(Long[] ids);

    /**
     * 批量更新个微SOP状态
     *
     * @param ids 个微SOP主键数组
     * @param status 状态
     * @return 结果
     */
    int updateStatusWxSopByIds(Long[] ids, Long status);

    /**
     * 根据筛选条件查询符合条件的客户
     *
     * @param param 筛选参数
     * @return 客户结果列表
     */
    @DataSource(DataSourceType.MASTER)
    List<WxFilterSopCustomersResult> selectFilterWxSopCustomers(WxSopTagsParam param);
}
